#include "global.h"
/* Keys   */
#define FIREKEY   ' '
#define PAUSEKEY    'p' 
#define SHIELDKEY   '0'
#define THRUSTKEY   '5'
#define HALTKEY 'h'
#define REFRESHKEY 'r'
#define CLOAKKEY           '.'
#define SELFDESTRUCTKEY '/'
#define SUPERFIRELAUNCHKEY '*'
#define SUPERFIRESPLITKEY  '-'
#define HYPERSPACEKEY '+'
#define LOCKSCANNERSKEY 'l'


/* This function will process the passed Xevent for the passed player.  
   This is the central point for converting user inputs into a call to 
   this application */

void ProcessEvent ( player,xdisplay, event)

     Xparam xdisplay; /* Record containing all of the X11 information
                         of the display that generated the event. */
     XEvent event;   /* X11 event record that has been generated by
                        then user action.  This event can be a mouse
                        button press / release or a keyboard button
                        press / release. */
     int player;    /* The id of the player that has generated the event */

{
  extern double speedscale;
  extern int numasts, rndint,endgame,
             counterstart,donewship,nextbul,dopause,rightborder,
             longrangeheight,longrangewidth;
  extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern DeviceType device[MAXPLAYERS+1];
  extern ShipType ship[MAXPLAYERS+1];
  extern VirtualType virtual;

  char text[30];
  KeySym key;
  static int level = 0;
  int len;
  int tmp_bullet;

  switch (event.type)
    { case MappingNotify:
        XRefreshKeyboardMapping ( &event);
        break;
      case ConfigureNotify:
        device[player].width = event.xconfigure.width-rightborder;
        device[player].height = event.xconfigure.height;
        device[player].scalex = (double) device[player].width / 
          physical[player].width;
        device[player].scaley = (double) device[player].height / 
          physical[player].height;
        device[player].longrangescaley = (double) longrangeheight / 
          virtual.height ;
        device[player].longrangescalex = (double) longrangewidth / 
          virtual.width ;

/*DD        printf("player %i scalex %f scaley %f\n",player,
               (float) device[player].longrangescalex,
               (float) device[player].longrangescaley);
*/
        XFreePixmap (xdisplay->disp, xdisplay->pixmap);
        xdisplay->pixmap = XCreatePixmap (xdisplay->disp, xdisplay->window, 
                                          device[player].width,
                                          device[player].height, 
                                          xdisplay->depth);
        XFillRectangle (xdisplay->disp, xdisplay->pixmap, xdisplay->pmgc, 0,
                        0, device[player].width, device[player].height);
        DrawStaticObjects(xdisplay,player);
        break;
      case ButtonPress:

        switch (event.xbutton.button)
          {
            /*## make common responses to keys / buttons 
              separete procedures(thrust) !!!! */
          case 1 :
            if (ship[player].hasturret) {
              if (!ship[player].reload && 
                  obj[player].alive && 
                  ship[player].system[weaponsys].status > OFFLINE &&
                  obj[player].energy > ship[player].fireenergy) {
                   obj[player].energy = obj[player].energy -  ship[player].fireenergy;
                   turretfire(player, event.xbutton.x,event.xbutton.y); 
              }
            } 
            else {     
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rotvel = obj[player].rotvel - 
                  ship[player].rotationincrement;             
              }
            break;
          case 2 :
            if (obj[player].energy > ship[player].thrustenergy &&
                ship[player].system[enginesys].status > OFFLINE) {
              ship[player].thrust_on = 1;
            }
            
                

            break;
          case 3 :
              
            if (ship[player].system[enginesys].status > OFFLINE)
              obj[player].rotvel = obj[player].rotvel + 
                ship[player].rotationincrement;             
            break;
 
          }
        break;
      case ButtonRelease:
        switch (event.xbutton.button)
          {
          case 1 :
            if (ship[player].system[enginesys].status > OFFLINE)
              obj[player].rotvel = 0; 
            
            break;
          case 2 :

            ship[player].thrust_on = 0;
            break;
          case 3 :
            if (ship[player].system[enginesys].status > OFFLINE)
              obj[player].rotvel = 0; 
 
            break;
          }
        break;
      case KeyPress:
        len = XLookupString (&event, text, 10, &key, 0);
        if (len == 1) switch (text[0])
          { case '4':
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rotvel = obj[player].rotvel - 
                  ship[player].rotationincrement;
              break;
            case 'a':
              makeasts(level);
              if (level < 6) level++;

              break;
            case REFRESHKEY:
              XClearWindow(xdisplay->disp,xdisplay->window);
                        
              DrawStaticObjects(xdisplay,player);

              DrawShipStatus(player,xdisplay);
            
              break;
            case HALTKEY:
              obj[player].rotvel= 0;
              obj[player].xvel= 0;
              obj[player].yvel= 0;
              break;
            case '6':
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rotvel = obj[player].rotvel + 
                                     ship[player].rotationincrement;
              break;
            case '7':
              if (ship[player].system[enginesys].status > OFFLINE)
                
                obj[player].rot -= pi/4; 
              break;
            case '9':
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rot += pi/4; 
              break;
            case '1':
              if (ship[player].system[enginesys].status > OFFLINE) {
                obj[player].rotvel = obj[player].rotvel - .02; 
              }
              break;
            case '3':
              if (ship[player].system[enginesys].status > OFFLINE) {
                obj[player].rotvel = obj[player].rotvel + .02; 
              }
              break;

            case THRUSTKEY:
              if (obj[player].energy > ship[player].thrustenergy &&
                  ship[player].system[enginesys].status > OFFLINE) {
                ship[player].thrust_on = 1;
              }

              break;
            case SUPERFIRESPLITKEY:
              if (obj[player].alive && ship[player].system[weaponsys].status > 
                  OFFLINE) { 
                if (obj[player].energy > ship[player].superfireenergy ) {
                  obj[player].energy = obj[player].energy - 
                    ship[player].superfireenergy;
                  tmp_bullet = nextbul;
                  fire(player);
                  superfire(tmp_bullet,player);
                  
                }

          
          
              }
  
              break;
            case SELFDESTRUCTKEY:
              if (obj[player].alive) selfdestruct(player); break;
            case FIREKEY:
              if (obj[player].alive && !ship[player].reload &&
                  ship[player].system[weaponsys].status > OFFLINE){
                
                if (obj[player].energy > ship[player].fireenergy ) {
                  /* there is enough energy to fire */
                  obj[player].energy = obj[player].energy - 
                    ship[player].fireenergy;
                  fire(player); 
                }
              }
              break;
            case LOCKSCANNERSKEY:
              if (obj[player].alive)
                { ship[player].scannedship = FindClosestShip(player);
                }
              break;
            case HYPERSPACEKEY:
              if (obj[player].alive)
                { hyper(player); 

                }
              break;
            case SHIELDKEY:
              
              if (obj[player].energy > ship[player].shieldhitenergy&&
                  ship[player].system[shieldsys].status > OFFLINE) {
                ship[player].shield_on = !ship[player].shield_on;
              }
              break;
            case CLOAKKEY:
              
              if (obj[player].energy > ship[player].cloakenergy&&
                  ship[player].system[cloaksys].status > OFFLINE) {
                ship[player].cloak_on = !ship[player].cloak_on;
              }
              break;
              /*#       case '.':  decrease delay 
                if (delay > 1) delay >>=1; break;
                case ',':  increase delay 
                delay <<=1; break; 
                */
            case 'm': /* decrease physical window */
              physical[player].width -= 100;
              physical[player].height -= 100;
  
              if (physical[player].width < 100)  physical[player].width = 10;
              if (physical[player].height < 100)  physical[player].height = 10;

              device[player].scalex = (double) device[player].width/
                physical[player].width;
              device[player].scaley = (double) device[player].height/
                physical[player].height;

              /*DDprintf(" physical W,H %d,%d was device W,H %d,%d \n",
                physical[player].width,
                physical[player].height,device[player].width,
                device[player].height);
                printf(" cale x,y %f %f \n",
                device[player].scalex,device[player].scaley);
                */
              break;
            case 'n': /* increase physical window */

              physical[player].width += 100;
              physical[player].height += 100;



              device[player].scalex = (double) device[player].width/
                physical[player].width;
            device[player].scaley = (double) device[player].height/
              physical[player].height;

              /*DD printf(" physical W,H %d,%d was device W,H %d,%d \n",
                physical[player].width,
                physical[player].height,device[player].width,
                 device[player].height);
                 printf(" scale x,y %f10 %f10 \n",device[player].scalex,
                 device[player].scaley);*/

              break;
            case 'u': /* increase speedscale  */
              speedscale += .1; break;
            case 'y': /* decrease speedscale  */
              speedscale -= .1; break;
            case 'b': /* increase moves/update */
              counterstart++; break;   
            case 'v': /* decrease moves/update */
              if (counterstart > 1) counterstart--;
              break; 
            case PAUSEKEY:  /* pause  */
              dopause = 1 - dopause; break;

            case 27:  /* quit   */
              endgame =1;
              break;
            case 's': /* start new ship */
              if (!obj[player].alive){
                donewship =1;
                
              }
              break;
            }
        break;
      case KeyRelease:
        len = XLookupString(&event, text, 10, &key, 0);
        if (len == 1) switch (text[0])
          { case '4': 
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rotvel = 0; 
              break;
            case '6':
              if (ship[player].system[enginesys].status > OFFLINE)
                obj[player].rotvel = 0; 
              break;
            case THRUSTKEY:
              ship[player].thrust_on = 0;
              
              break; 
              
            }
        
      }
  
  
}
